﻿SET SEARCH_PATH TO REPRESENTANTES , CASILLAS , GEOGRAFICO , PARTIDOSPOLITICOS;
/**
DROP FUNCTION INSERTA_REPRESENTANTE_PRELIMINAR(ID_ESTADO_IN  DECIMAL(2,0) , 
ID_DISTRITO_IN DECIMAL(2,0), ASOCIACION_IN DECIMAL(1,0),PARTIDO_CANDIDATO_IN DECIMAL(6,0), 
TIPO_REPRESENTANTE_IN CHAR(1), SECCION_IN DECIMAL(4,0), CASILLA_IN CHAR(6), 
CALIDAD_REPRESENTANTE_IN CHAR(1) , CLAVE_ELECTOR_IN CHAR(11 ), NOMBRE_IN VARCHAR(35), 
APELLIDO_PATERNO_IN VARCHAR(35), APELLIDO_MATERNO_IN VARCHAR(35), SEXO_IN CHAR(1), 
DOMICILIO_IN VARCHAR(200));
**/

CREATE OR REPLACE FUNCTION INSERTA_REPRESENTANTE_PRELIMINAR (ID_ESTADO_IN  DECIMAL(2,0) , 
ID_DISTRITO_IN DECIMAL(2,0), ASOCIACION_IN DECIMAL(1,0),PARTIDO_CANDIDATO_IN DECIMAL(6,0), 
TIPO_REPRESENTANTE_IN CHAR(1), SECCION_IN DECIMAL(4,0), CASILLA_IN CHAR(6), 
CALIDAD_REPRESENTANTE_IN CHAR(1) , CLAVE_ELECTOR_IN CHAR(11), NOMBRE_IN VARCHAR(35), 
APELLIDO_PATERNO_IN VARCHAR(35), APELLIDO_MATERNO_IN VARCHAR(35), SEXO_IN CHAR(1), 
DOMICILIO_IN VARCHAR(200) ) 
  RETURNS VOID AS $$
    DECLARE
      VAR_FECHA_HORA TIMESTAMP := NOW();
      VAR_USUARIO VARCHAR(50) := CURRENT_USER;
      VAR_ID_REPRE_DATOS INTEGER;
      VAR_ID_REPRE_PRE INTEGER;
    BEGIN
          IF NOT EXISTS(SELECT * FROM REPRESENTANTES_DATOS WHERE CLAVE_ELECTOR = CLAVE_ELECTOR_IN)
      THEN
           IF ( IS_CADENA(NOMBRE_IN) AND IS_CADENA(APELLIDO_PATERNO_IN) AND IS_CADENA(APELLIDO_MATERNO_IN) )
            THEN
            IF ( VALIDA_CLAVE_ELECTOR (CLAVE_ELECTOR_IN) )
             THEN
              VAR_ID_REPRE_DATOS := (SELECT GENERA_ID_REPRE_DATO () );
              INSERT INTO REPRESENTANTES_DATOS VALUES (VAR_ID_REPRE_DATOS , UPPER(CLAVE_ELECTOR_IN), 
                  TRIM(NOMBRE_IN),TRIM(APELLIDO_PATERNO_IN), TRIM(APELLIDO_MATERNO_IN),
                  TRIM(UPPER(SEXO_IN)),TRIM(DOMICILIO_IN),VAR_USUARIO,VAR_FECHA_HORA );
             ELSE 
              RAISE EXCEPTION 'UPS! SE GENERO UN ERROR AL VALIDAR LA CLAVE DE ELECTOR. -> %' ,  $9  
              USING HINT = 'REVISA QUE TU CLAVE DE ELECTOR SE VALIDA.';
              RETURN  ;
             END IF;
      ELSE
              RAISE EXCEPTION 'UPS! SE GENERO UN ERROR AL VALIDAR ALGUNA DE LAS SIGUIENTES CADENAS. -> %' , 
                                              $10 || ' ' ||$11 || ' ' || $12 
              USING HINT = 'REVISA QUE TU CADENA SEA UNA CADENA VALIDA.';
              RETURN  ;
            END IF;
          ELSE
            VAR_ID_REPRE_DATOS := (SELECT REGRESA_ID_REPRE_DATO(CLAVE_ELECTOR_IN ) );
        END IF;
        VAR_ID_REPRE_PRE := (SELECT GENERA_ID_REPRE_PRE () );
        INSERT INTO  REPRESENTANTES_PRELIMINARES  VALUES ( VAR_ID_REPRE_PRE , VAR_ID_REPRE_DATOS ,
           ID_ESTADO_IN, ID_DISTRITO_IN, ASOCIACION_IN, PARTIDO_CANDIDATO_IN, CLAVE_ELECTOR_IN ,
           VAR_USUARIO, VAR_FECHA_HORA);
      IF TIPO_REPRESENTANTE_IN = 'C'
         THEN
          IF NOT EXISTS (SELECT * FROM REPRESENTANTES_CASILLA WHERE id_representante_datos = VAR_ID_REPRE_DATOS AND id_estado = ID_ESTADO_IN
           AND id_distrito_federal =  ID_DISTRITO_IN AND  calidad_representante =  CALIDAD_REPRESENTANTE_IN AND SECCION =  SECCION_IN AND
           tipo_casilla =  CASILLA_IN)
              THEN
                INSERT INTO REPRESENTANTES_CASILLA VALUES (VAR_ID_REPRE_PRE, VAR_ID_REPRE_DATOS , ID_ESTADO_IN,ID_DISTRITO_IN, 
                CALIDAD_REPRESENTANTE_IN,  SECCION_IN , CASILLA_IN ,VAR_USUARIO, VAR_FECHA_HORA );
              ELSE
                 RAISE EXCEPTION 'UPS! SE GENERO UN ERROR AL VALIDAR AL REPRESENTANTE ' 
                 USING HINT = 'REVISA QUE TU REPRESENTANTE NO ESTE REGISTRADO.';
                 RETURN  ;
             END IF;
        ELSEIF   TIPO_REPRESENTANTE_IN = 'G'
          THEN 
           INSERT INTO REPRESENTANTES_GENERALES VALUES (VAR_ID_REPRE_PRE, VAR_ID_REPRE_DATOS , ID_ESTADO_IN,ID_DISTRITO_IN,
              VAR_USUARIO, VAR_FECHA_HORA );
        ELSE 
           RAISE EXCEPTION 'UPS! NO EXISTE EL TIPO DE REPRESENTANTE. -> %' , $5
           USING HINT = 'REVISA QUE TU TIPO_REPRESENTANTE SEA VALIDO.';
           RETURN  ;
        END IF;
      END;
    $$ LANGUAGE PLPGSQL;

COMMENT ON FUNCTION INSERTA_REPRESENTANTE_PRELIMINAR (ID_ESTADO_IN  DECIMAL(2,0) , 
ID_DISTRITO_IN DECIMAL(2,0), ASOCIACION_IN DECIMAL(1,0),PARTIDO_CANDIDATO_IN DECIMAL(6,0), 
TIPO_REPRESENTANTE_IN CHAR(1), SECCION_IN DECIMAL(4,0), CASILLA_IN CHAR(6), 
CALIDAD_REPRESENTANTE_IN CHAR(1) , CLAVE_ELECTOR_IN CHAR(11 ), NOMBRE_IN VARCHAR(35), 
APELLIDO_PATERNO_IN VARCHAR(35), APELLIDO_MATERNO_IN VARCHAR(35), SEXO_IN CHAR(1), 
DOMICILIO_IN VARCHAR(200) )  IS 'Procedimiento encargado de guardar información de un representante preliminar, para esto,
 primero se busca en la tabla de representante_datos si ya se cuenta con la información del representante que se desea agregar 
 solo se almacena  información en la tabla representante_pre en caso contrario se guarda el registro en representante_datos y representantes_pre.';